/*
 * Ubiquity REST API
 *
 * Ubiquity provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple cryptocurrencies.  [Documentation](https://app.blockdaemon.com/docs/ubiquity)  ### Protocols #### Mainnet The following protocols are currently supported: * bitcoin * ethereum * polkadot * xrp * algorand * stellar * dogecoin * oasis * near * terra * litecoin * bitcoincash * tezos  #### Testnet * bitcoin/testnet * ethereum/ropsten * dogecoin/testnet * litecoin/testnet * bitcoincash/testnet  #### Native Ubiquity provides native access to all Blockchain nodes it supports. * bitcoin/(mainnet | testnet) - [RPC Documentation](https://developer.bitcoin.org/reference/rpc/) * ethereum/(mainnet | ropsten) - [RPC Documentation](https://ethereum.org/en/developers/docs/apis/json-rpc/) * polkadot/mainnet - [Sidecar API Documentation](https://paritytech.github.io/substrate-api-sidecar/dist/) * polkadot/mainnet/http-rpc - [Polkadot RPC Documentation](https://polkadot.js.org/docs/substrate/rpc/) * algorand/mainnet - [Algod API Documentation](https://developer.algorand.org/docs/reference/rest-apis/algod/) * stellar/mainnet - [Stellar Horizon API Documentation](https://developers.stellar.org/api) * dogecoin/(mainnet | testnet) - [Dogecoin API Documentaion](https://developer.bitcoin.org/reference/rpc/) * oasis/mainnet - [Oasis Rosetta Gateway Documentation](https://www.rosetta-api.org/docs/api_identifiers.html#network-identifier) * near/mainnet - [NEAR RPC Documentation](https://docs.near.org/docs/api/rpc) * terra/mainnet - [Terra RPC Documentation](https://docs.terra.money/docs/develop/how-to/endpoints.html) * litecoin/mainnet - [Litecoin RPC Documentation](https://litecoin.info/index.php/Litecoin_API) * bitcoincash/mainnet - [Bitcoin Cash RPC Documentation](https://docs.bitcoincashnode.org/doc/json-rpc/) * tezos/mainnet - [Tezos RPC Documentation](https://tezos.gitlab.io/developer/rpc.html)   A full URL example: https://ubiquity.api.blockdaemon.com/v1/bitcoin/mainnet  ##### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
)

// Asset struct for Asset
type Asset struct {
	TokenId    *int64         `json:"token_id,omitempty"`
	ImageUrl   *string        `json:"image_url,omitempty"`
	Name       *string        `json:"name,omitempty"`
	Contract   *Contract      `json:"contract,omitempty"`
	Wallets    *[]AssetWallet `json:"wallets,omitempty"`
	Attributes *[]AssetTrait  `json:"attributes,omitempty"`
	MintDate   *int64         `json:"mint_date,omitempty"`
}

// NewAsset instantiates a new Asset object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAsset() *Asset {
	this := Asset{}
	return &this
}

// NewAssetWithDefaults instantiates a new Asset object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAssetWithDefaults() *Asset {
	this := Asset{}
	return &this
}

// GetTokenId returns the TokenId field value if set, zero value otherwise.
func (o *Asset) GetTokenId() int64 {
	if o == nil || o.TokenId == nil {
		var ret int64
		return ret
	}
	return *o.TokenId
}

// GetTokenIdOk returns a tuple with the TokenId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Asset) GetTokenIdOk() (*int64, bool) {
	if o == nil || o.TokenId == nil {
		return nil, false
	}
	return o.TokenId, true
}

// HasTokenId returns a boolean if a field has been set.
func (o *Asset) HasTokenId() bool {
	if o != nil && o.TokenId != nil {
		return true
	}

	return false
}

// SetTokenId gets a reference to the given int64 and assigns it to the TokenId field.
func (o *Asset) SetTokenId(v int64) {
	o.TokenId = &v
}

// GetImageUrl returns the ImageUrl field value if set, zero value otherwise.
func (o *Asset) GetImageUrl() string {
	if o == nil || o.ImageUrl == nil {
		var ret string
		return ret
	}
	return *o.ImageUrl
}

// GetImageUrlOk returns a tuple with the ImageUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Asset) GetImageUrlOk() (*string, bool) {
	if o == nil || o.ImageUrl == nil {
		return nil, false
	}
	return o.ImageUrl, true
}

// HasImageUrl returns a boolean if a field has been set.
func (o *Asset) HasImageUrl() bool {
	if o != nil && o.ImageUrl != nil {
		return true
	}

	return false
}

// SetImageUrl gets a reference to the given string and assigns it to the ImageUrl field.
func (o *Asset) SetImageUrl(v string) {
	o.ImageUrl = &v
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *Asset) GetName() string {
	if o == nil || o.Name == nil {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Asset) GetNameOk() (*string, bool) {
	if o == nil || o.Name == nil {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *Asset) HasName() bool {
	if o != nil && o.Name != nil {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *Asset) SetName(v string) {
	o.Name = &v
}

// GetContract returns the Contract field value if set, zero value otherwise.
func (o *Asset) GetContract() Contract {
	if o == nil || o.Contract == nil {
		var ret Contract
		return ret
	}
	return *o.Contract
}

// GetContractOk returns a tuple with the Contract field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Asset) GetContractOk() (*Contract, bool) {
	if o == nil || o.Contract == nil {
		return nil, false
	}
	return o.Contract, true
}

// HasContract returns a boolean if a field has been set.
func (o *Asset) HasContract() bool {
	if o != nil && o.Contract != nil {
		return true
	}

	return false
}

// SetContract gets a reference to the given Contract and assigns it to the Contract field.
func (o *Asset) SetContract(v Contract) {
	o.Contract = &v
}

// GetWallets returns the Wallets field value if set, zero value otherwise.
func (o *Asset) GetWallets() []AssetWallet {
	if o == nil || o.Wallets == nil {
		var ret []AssetWallet
		return ret
	}
	return *o.Wallets
}

// GetWalletsOk returns a tuple with the Wallets field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Asset) GetWalletsOk() (*[]AssetWallet, bool) {
	if o == nil || o.Wallets == nil {
		return nil, false
	}
	return o.Wallets, true
}

// HasWallets returns a boolean if a field has been set.
func (o *Asset) HasWallets() bool {
	if o != nil && o.Wallets != nil {
		return true
	}

	return false
}

// SetWallets gets a reference to the given []AssetWallet and assigns it to the Wallets field.
func (o *Asset) SetWallets(v []AssetWallet) {
	o.Wallets = &v
}

// GetAttributes returns the Attributes field value if set, zero value otherwise.
func (o *Asset) GetAttributes() []AssetTrait {
	if o == nil || o.Attributes == nil {
		var ret []AssetTrait
		return ret
	}
	return *o.Attributes
}

// GetAttributesOk returns a tuple with the Attributes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Asset) GetAttributesOk() (*[]AssetTrait, bool) {
	if o == nil || o.Attributes == nil {
		return nil, false
	}
	return o.Attributes, true
}

// HasAttributes returns a boolean if a field has been set.
func (o *Asset) HasAttributes() bool {
	if o != nil && o.Attributes != nil {
		return true
	}

	return false
}

// SetAttributes gets a reference to the given []AssetTrait and assigns it to the Attributes field.
func (o *Asset) SetAttributes(v []AssetTrait) {
	o.Attributes = &v
}

// GetMintDate returns the MintDate field value if set, zero value otherwise.
func (o *Asset) GetMintDate() int64 {
	if o == nil || o.MintDate == nil {
		var ret int64
		return ret
	}
	return *o.MintDate
}

// GetMintDateOk returns a tuple with the MintDate field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Asset) GetMintDateOk() (*int64, bool) {
	if o == nil || o.MintDate == nil {
		return nil, false
	}
	return o.MintDate, true
}

// HasMintDate returns a boolean if a field has been set.
func (o *Asset) HasMintDate() bool {
	if o != nil && o.MintDate != nil {
		return true
	}

	return false
}

// SetMintDate gets a reference to the given int64 and assigns it to the MintDate field.
func (o *Asset) SetMintDate(v int64) {
	o.MintDate = &v
}

func (o Asset) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.TokenId != nil {
		toSerialize["token_id"] = o.TokenId
	}
	if o.ImageUrl != nil {
		toSerialize["image_url"] = o.ImageUrl
	}
	if o.Name != nil {
		toSerialize["name"] = o.Name
	}
	if o.Contract != nil {
		toSerialize["contract"] = o.Contract
	}
	if o.Wallets != nil {
		toSerialize["wallets"] = o.Wallets
	}
	if o.Attributes != nil {
		toSerialize["attributes"] = o.Attributes
	}
	if o.MintDate != nil {
		toSerialize["mint_date"] = o.MintDate
	}
	return json.Marshal(toSerialize)
}

type NullableAsset struct {
	value *Asset
	isSet bool
}

func (v NullableAsset) Get() *Asset {
	return v.value
}

func (v *NullableAsset) Set(val *Asset) {
	v.value = val
	v.isSet = true
}

func (v NullableAsset) IsSet() bool {
	return v.isSet
}

func (v *NullableAsset) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAsset(val *Asset) *NullableAsset {
	return &NullableAsset{value: val, isSet: true}
}

func (v NullableAsset) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAsset) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
